.286
IDEAL
;
ASSUME          CS:FADECODE, DS:FADECODE, ES:FADECODE, SS:NOTHING
;
SEGMENT         FADECODE PARA PUBLIC
;
PUBLIC          FADEPAL
;
PROC            FADEPAL

NumColors       EQU     <[bp+14]>
Intensity       EQU     <[bp+12]>
WorkSeg         EQU     <[bp+10]>
SourceOfs       EQU     <[bp+08]>
DestOfs         EQU     <[bp+06]>

P               =       10

                Push    bp
                Mov     bp, sp
                Push    ds es si di

                Mov     ax, WorkSeg
                Mov     ds, ax
                Mov     es, ax

                Mov     si, SourceOfs
                Mov     di, DestOfs

                Mov     cx, NumColors
                Mov     ax, cx
                Shl     ax, 1
                Add     cx, ax

                Mov     bx, Intensity
                Cmp     bx, 256
                Jb      @@10
                Rep     Movsb
                Jmp     @@Exit
;
@@10:           Push    cx
                And     cx, 7
                Jz      @@30
@@20:           Lodsb                   ;new_i% = (old_i% * intensity) / 256
                Mul     bl
                Mov     al, ah
                Stosb
                Loop    @@20
@@30:           Pop     cx
                Shr     cx, 3
                Jz      @@Exit
                Mov     dx, 8
;
ALIGN 4
@@40:           reptcount = 0
                REPT    8
                Lodsb
                Mul     bl
                Mov     [di+reptcount], ah
                reptcount = reptcount + 1
                ENDM
                Add     di, dx
                Loop    @@40
;
@@Exit:         Pop     di si es ds bp
                Retf    P

ENDP            FADEPAL
;
PUBLIC          SETPAL
;
PROC            SETPAL

NumColors       EQU     <[bp+10]>
SourceSeg       EQU     <[bp+08]>
SourceOfs       EQU     <[bp+06]>

P               =       6

                Push    bp
                Mov     bp, sp
                Push    ds es si di

                Lds     si, SourceOfs
                Mov     cx, NumColors
                Jcxz    @@Exit

                Mov     dx, 03DAh

@@1:            In      al, dx
                And     al, 8
                Jnz     @@1             ;wait while still in vertical retrace

@@2:            In      al, dx
                And     al, 8
                Jz      @@2             ;while while still on screen

                                        ;at this point, we're now at the
                                        ;start of the vertical retrace

                Mov     dx, 03C8h       ;start are DAC register zero
                Xor     al, al
                Out     dx, al
                Inc     dx
                Mov     bx, 0DAC9h

; in vertical retrace loop
ALIGN 4
@@10:           Lodsb                   ;get red
                Out     dx, al          ;send red

                Lodsb                   ;get green
                Out     dx, al          ;send green

                Mov     dl, bh
                In      al, dx
                Shr     al, 1           ;test to see if the screen has turned
                Jnc     @@VisableNow    ;back on...

                Mov     dl, bl
                Lodsb                   ;get blue
                Out     dx, al          ;send blue

                Loop    @@10
                Jmp     @@Exit
;
@@VisableNow:   In      al, dx          ;wait for a horizontal retrace
                Shr     al, 1
                Jnc     @@VisableNow

                Mov     dl, bl
                Lodsb                   ;send blue
                Out     dx, al

                Dec     cx              ;all done? (just in case)
                Jz      @@Exit
; out of vertical retrace loop
ALIGN 4
@@20:           Lodsb                   ;could use Outsb instead
                Out     dx, al

                Lodsb
                Out     dx, al

                Mov     dl, bh
@@30:           In      al, dx          ;wait for horizontal retrace
                Shr     al, 1
                Jnc     @@30

                Mov     dl, bl
                Lodsb
                Out     dx, al

                Mov     dl, bh
@@40:           In      al, dx
                Shr     al, 1
                Jc      @@40            ;wait for end of horizontal retrace

                Mov     dl, bl

                Loop    @@20
;
@@Exit:         Pop     di si es ds bp
                Retf    P

ENDP            SETPAL
;
ENDS            FADECODE
;
END
