;----------------------------------------------------------------
.286
IDEAL
;----------------------------------------------------------------
GROUP           DGROUP _DATA
;----------------------------------------------------------------
SEGMENT         _DATA PARA PUBLIC 'DATA'
ENDS            _DATA
;----------------------------------------------------------------
EXTRN           _CheckError:FAR
;----------------------------------------------------------------
SEGMENT         FILEIO_TEXT PARA PUBLIC 'CODE'
;----------------------------------------------------------------
ASSUME          CS:FILEIO_TEXT, DS:DGROUP, ES:NOTHING, SS:DGROUP
;----------------------------------------------------------------
PUBLIC          _FileOpen
PROC            _FileOpen

FileName        EQU     <[bp+06]>
Attr            EQU     <[bp+08]>
Handle          EQU     <[bp+10]>

                Push    bp
                Mov     bp, sp

                Mov     dx, FileName
                Mov     al, Attr
                Mov     ah, 03Dh
                Int     021h
                Call    _CheckError
                Jc      @@Error
                Mov     bx, Handle
                Mov     [bx], ax
                Xor     ax, ax

@@Error:        Pop     bp
                Retf

ENDP            _FileOpen
;----------------------------------------------------------------
PUBLIC          _FileCreate
PROC            _FileCreate

FileName        EQU     <[bp+06]>
Attr            EQU     <[bp+08]>
Handle          EQU     <[bp+10]>

                Push    bp
                Mov     bp, sp

                Mov     dx, FileName
                Mov     cx, Attr
                Mov     ah, 03Ch
                Int     021h
                Call    _CheckError
                Jc      @@Error
                Mov     bx, Handle
                Mov     [bx], ax
                Xor     ax, ax

@@Error:        Pop     bp
                Retf

ENDP            _FileCreate
;----------------------------------------------------------------
PUBLIC          _FileMake
PROC            _FileMake

FileName        EQU     <[bp+06]>
Attr            EQU     <[bp+08]>
Handle          EQU     <[bp+10]>

                Push    bp
                Mov     bp, sp

                Mov     dx, FileName
                Mov     cx, Attr
                Mov     ah, 05Bh
                Int     021h
                Call    _CheckError
                Jc      @@Error
                Mov     bx, Handle
                Mov     [bx], ax
                Xor     ax, ax

@@Error:        Pop     bp
                Retf

ENDP            _FileMake
;----------------------------------------------------------------
PUBLIC          _FileClose
PROC            _FileClose

Handle          EQU     <[bp+06]>

                Push    bp
                Mov     bp, sp

                Mov     bx, Handle
                Mov     ah, 03Eh
                Int     021h
                Call    _CheckError
                Jc      @@Error
                Xor     ax, ax
@@Error:
                Pop     bp
                Retf

ENDP            _FileClose
;----------------------------------------------------------------
PUBLIC          _FileRead
PROC            _FileRead

Handle          EQU     <[bp+06]>
ReadOfs         EQU     <[bp+08]>
ReadSeg         EQU     <[bp+10]>
ReadLen         EQU     <[bp+12]>

                Push    bp
                Mov     bp, sp

                Mov     cx, ReadLen
                Push    cx ds
                Mov     bx, Handle
                Lds     dx, ReadOfs
                Mov     ah, 03Fh
                Int     021h
                Pop     ds cx
                Call    _CheckError
                Jc      @@Error
                Cmp     ax, cx
                Je      @@Exit
                Mov     ax, -11
                Jmp     @@Error

@@Exit:         Xor     ax, ax

@@Error:        Pop     bp
                Retf

ENDP            _FileRead
;----------------------------------------------------------------
PUBLIC          _FileWrite
PROC            _FileWrite

Handle          EQU     <[bp+06]>
WriteOfs        EQU     <[bp+08]>
WriteSeg        EQU     <[bp+10]>
WriteLen        EQU     <[bp+12]>

                Push    bp
                Mov     bp, sp

                Mov     cx, WriteLen
                Push    cx ds
                Mov     bx, Handle
                Lds     dx, WriteOfs
                Mov     ah, 040h
                Int     021h
                Pop     ds cx
                Call    _CheckError
                Jc      @@Error
                Cmp     ax, cx
                Je      @@Exit
                Mov     ax, -10
                Jmp     @@Error

@@Exit:         Xor     ax, ax

@@Error:        Pop     bp
                Retf

ENDP            _FileWrite
;----------------------------------------------------------------
PUBLIC          _FileSeek
PROC            _FileSeek

Handle          EQU     <[bp+06]>
Method          EQU     <[bp+08]>
SeekOfsL        EQU     <[bp+10]>
SeekOfsH        EQU     <[bp+12]>

                Push    bp
                Mov     bp, sp

                Mov     dx, SeekOfsL
                Mov     cx, SeekOfsH
                Mov     bx, Handle
                Mov     al, Method
                Mov     ah, 042h
                Int     021h
                Call    _CheckError
                Jc      @@Exit
                Xor     ax, ax

@@Exit:         Pop     bp
                Retf

ENDP            _FileSeek
;----------------------------------------------------------------
PUBLIC          _FilePointer
PROC            _FilePointer

Handle          EQU     <[bp+06]>
SeekOfs         EQU     <[bp+08]>

                Push    bp
                Mov     bp, sp

                Mov     bx, Handle
                Xor     cx, cx
                Xor     dx, dx
                Mov     ax, 04201h
                Int     021h
                Call    _CheckError
                Jc      @@Error

                Mov     bx, SeekOfs
                Mov     [bx], ax
                Mov     [bx+2], dx
                Xor     ax, ax

@@Error:        Pop     bp
                Retf

ENDP            _FilePointer
;----------------------------------------------------------------
PUBLIC          _FileSize
PROC            _FileSize

Handle          EQU     <[bp+06]>
FileLen         EQU     <[bp+08]>

TempH           EQU     <[bp-02]>
TempL           EQU     <[bp-04]>


                Push    bp
                Mov     bp, sp
                Sub     sp, 4

                Lea     ax, TempL
                Push    ax
                Push    Handle
                Call    FAR _FilePointer
                Add     sp, 4
                And     ax, ax
                Jnz     @@Exit

                Push    0
                Push    0
                Push    2
                Push    Handle
                Call    FAR _FileSeek
                Add     sp, 8
                And     ax, ax
                Jnz     @@Exit

                Mov     bx, FileLen
                Push    bx
                Push    Handle
                Call    FAR _FilePointer
                Add     sp, 4
                And     ax, ax
                Jnz     @@Exit

                Push    TempH
                Push    TempL
                Push    0
                Push    Handle
                Call    FAR _FileSeek
                Add     sp, 8

@@Exit:         Mov     sp, bp
                Pop     bp
                Retf

ENDP            _FileSize
;----------------------------------------------------------------
PUBLIC          _FileRename
PROC            _FileRename

OldName         EQU     <[bp+06]>
NewName         EQU     <[bp+08]>

                Push    bp
                Mov     bp, sp
                Push    di

                Mov     dx, OldName
                Mov     di, NewName
                Push    ds
                Pop     es
                Mov     ah, 056h
                Int     021h
                Call    _CheckError
                Jc      @@Error
                Xor     ax, ax

@@Error:        Pop     di bp
                Retf

ENDP            _FileRename
;----------------------------------------------------------------
PUBLIC          _FileDelete
PROC            _FileDelete

FileName        EQU     <[bp+06]>

                Push    bp
                Mov     bp, sp

                Mov     dx, FileName
                Mov     ah, 041h
                Int     021h
                Call    _CheckError
                Jc      @@Error
                Xor     ax, ax

@@Error:        Pop     bp
                Retf

ENDP            _FileDelete
;----------------------------------------------------------------
PUBLIC          _FileSetDateTime
PROC            _FileSetDateTime

Handle          EQU     <[bp+06]>
NewDate         EQU     <[bp+08]>
NewTime         EQU     <[bp+10]>

                Push    bp
                Mov     bp, sp

                Mov     dx, NewDate
                Mov     cx, NewTime
                Mov     bx, Handle
                Mov     ax, 05701h
                Int     021h
                Call    _CheckError
                Jc      @@Error
                Xor     ax, ax

@@Error:        Pop     bp
                Retf

ENDP            _FileSetDateTime
;----------------------------------------------------------------
PUBLIC          _FileGetDateTime
PROC            _FileGetDateTime

Handle          EQU     <[bp+06]>
FileDate        EQU     <[bp+08]>
FileTime        EQU     <[bp+10]>

                Push    bp
                Mov     bp, sp

                Mov     bx, Handle
                Mov     ax, 05700h
                Int     021h
                Call    _CheckError
                Jc      @@Error
                Mov     bx, FileDate
                Mov     [bx], dx
                Mov     bx, FileTime
                Mov     [bx], cx
                Xor     ax, ax

@@Error:        Pop     bp
                Retf

ENDP            _FileGetDateTime
;----------------------------------------------------------------
PUBLIC          _FileSetAttr
PROC            _FileSetAttr

FileName        EQU     <[bp+06]>
NewAttr         EQU     <[bp+08]>

                Push    bp
                Mov     bp, sp

                Mov     dx, FileName
                Mov     cx, NewAttr
                Mov     ax, 04301h
                Int     021h
                Call    _CheckError
                Jc      @@Error
                Xor     ax, ax

@@Error:        Pop     bp
                Retf

ENDP            _FileSetAttr
;----------------------------------------------------------------
PUBLIC          _FileGetAttr
PROC            _FileGetAttr

FileName        EQU     <[bp+06]>
FileAttr        EQU     <[bp+08]>

                Push    bp
                Mov     bp, sp

                Mov     dx, FileName
                Mov     ax, 04300h
                Int     021h
                Call    _CheckError
                Jc      @@Error
                Xor     ax, ax
                Mov     bx, FileAttr
                Mov     [bx], cx

@@Error:        Pop     bp
                Retf

ENDP            _FileGetAttr
;----------------------------------------------------------------
PUBLIC          _DeleteDir
PROC            _DeleteDir

PathName        EQU     <[bp+06]>

                Push    bp
                Mov     bp, sp

                Mov     dx, PathName
                Mov     ah, 03Ah
                Int     021h
                Call    _CheckError
                Jc      @@Error
                Xor     ax, ax

@@Error:        Pop     bp
                Retf

ENDP            _DeleteDir
;----------------------------------------------------------------
ENDS            FILEIO_TEXT
;----------------------------------------------------------------
END
