.286
IDEAL
;
MAXHANDLES      =       16
;
EXTRN           B_OnExit:FAR
;
ASSUME          CS:XMSCode, DS:XMSCode, ES:XMSCode, SS:NOTHING
;
SEGMENT         XMSCode PARA PUBLIC
;
Initialized     dw      0
Dispatcher      dd      0

NumHandles      dw      0
HandleTable     dw      MAXHANDLES dup(0)

TotalBytesL     dw      0
TotalBytesH     dw      0

SourceHandle    dw      0
SourceOfsL      dw      0
SourceOfsH      dw      0

DestHandle      dw      0
DestOfsL        dw      0
DestOfsH        dw      0
;
PUBLIC          _XMSInit
;
PROC            _XMSInit

                Push    ds es si di
;
                Cmp     [cs:Initialized], 1
                Je      @@Ok
;
                Mov     ax, 04300h
                Int     02Fh
                Cmp     al, 080h
                Jne     @@NoXMS
;
                Mov     ax, 04310h
                Int     02Fh
                Mov     [WORD cs:Dispatcher], bx
                Mov     [WORD cs:Dispatcher+2], es
                Mov     [cs:Initialized], 1
;
                Push    cs
                Push    offset _XMSFreeAll
                Call    B_OnExit
;
@@Ok:           Xor     ax, ax
@@Exit:         Pop     di si es ds
                Retf
;
@@NoXMS:        Mov     ax, 1
                Jmp     @@Exit

ENDP            _XMSInit
;
PUBLIC          _XMSMaxFree
;
PROC            _XMSMaxFree

MaxFree         EQU     <[bp+06]>

                Push    bp
                Mov     bp, sp
                Push    ds es si di
;
                Cmp     [cs:Initialized], 0
                Je      @@NoXMS
;
                Mov     ah, 8
                Xor     bx, bx
                Call    [cs:Dispatcher]
                And     bl, bl
                Jnz     @@NoXMS
                Mov     bx, MaxFree
                Mov     [ss:bx], dx
                Xor     ax, ax
@@Exit:         Pop     di si es ds bp
                Retf
;
@@NoXMS:        Mov     ax, 1
                Jmp     @@Exit

ENDP            _XMSMaxFree
;
PUBLIC          _XMSAllocate
;
PROC            _XMSAllocate

Kilobytes       EQU     <[bp+06]>
Handle          EQU     <[bp+08]>

                Push    bp
                Mov     bp, sp
                Push    ds es si di
;
                Push    cs cs
                Pop     ds es
;
                Cmp     [Initialized], 0
                Je      @@Error
;
                Cmp     [NumHandles], MAXHANDLES
                Je      @@Error
;
                Mov     dx, Kilobytes
                Mov     ax, 0900h
                Call    [cs:Dispatcher]
                And     ax, ax
                Jz      @@Error
                Mov     bx, Handle
                Mov     [ss:bx], dx
;
                Mov     bx, [NumHandles]
                Inc     [NumHandles]
                Mov     si, offset HandleTable
@@10:           Cmp     [WORD si], 0
                Je      @@20
                Inc     si
                Inc     si
                Jmp     @@10
@@20:           Mov     [si], dx
                Xor     ax, ax
;
@@Exit:         Pop     di si es ds
                Pop     bp
                Retf
;
@@Error:        Mov     ax, 1
                Jmp     @@Exit

ENDP            _XMSAllocate
;
PUBLIC          _XMSFree
;
PROC            _XMSFree

Handle          EQU     <[bp+06]>

                Push    bp
                Mov     bp, sp
                Push    ds es si di
;
                Push    cs cs
                Pop     ds es
;
                Cmp     [Initialized], 0
                Je      @@Error
;
                Cmp     [NumHandles], 0
                Je      @@Error
                Mov     dx, Handle
                And     dx, dx
                Je      @@Error
                Mov     si, offset HandleTable
                Mov     cx, MAXHANDLES
@@10:           Cmp     [si], dx
                Je      @@20
                Inc     si
                Inc     si
                Loop    @@10
                Jmp     @@Error
;
@@20:           Mov     [WORD si], 0
                Dec     [NumHandles]

                Mov     ax, 0A00h
                Call    [cs:Dispatcher]
                And     ax, ax
                Jz      @@Error
                Xor     ax, ax
;
@@Exit:         Pop     di si es ds
                Pop     bp
                Retf
;
@@Error:        Mov     ax, 1
                Jmp     @@Exit

ENDP            _XMSFree
;
PUBLIC          _CopyToXMS
;
PROC            _CopyToXMS

PDestHandle     EQU     <[bp+06]>
PDestOfsL       EQU     <[bp+08]>
PDestOfsH       EQU     <[bp+10]>
PSourceSeg      EQU     <[bp+12]>
PSourceOfs      EQU     <[bp+14]>
PNumBytesL      EQU     <[bp+16]>
PNumBytesH      EQU     <[bp+18]>

                Push    bp
                Mov     bp, sp
                Push    ds es si di
;
                Push    cs cs
                Pop     ds es
;
                Cmp     [Initialized], 0
                Je      @@Error
;
                Mov     di, offset TotalBytesL
                Mov     si, di

                Mov     ax, PNumBytesL
                Stosw
                Mov     ax, PNumBytesH
                Stosw

                Xor     ax, ax
                Stosw
                Mov     ax, PSourceOfs
                Stosw
                Mov     ax, PSourceSeg
                Stosw

                Mov     ax, PDestHandle
                Stosw
                Mov     ax, PDestOfsL
                Stosw
                Mov     ax, PDestOfsH
                Stosw

                Mov     ax, 0B00h
                Call    [Dispatcher]
                And     ax, ax
                Jz      @@Error
                Xor     ax, ax
;
@@Exit:         Pop     di si es ds bp
                Retf
;
@@Error:        Mov     ax, 1
                Jmp     @@Exit

ENDP            _CopyToXMS
;
PUBLIC          _CopyFromXMS
;
PROC            _CopyFromXMS

PSourceHandle   EQU     <[bp+06]>
PSourceOfsL     EQU     <[bp+08]>
PSourceOfsH     EQU     <[bp+10]>
PDestSeg        EQU     <[bp+12]>
PDestOfs        EQU     <[bp+14]>
PNumBytesL      EQU     <[bp+16]>
PNumBytesH      EQU     <[bp+18]>

                Push    bp
                Mov     bp, sp
                Push    ds es si di
;
                Push    cs cs
                Pop     ds es
;
                Cmp     [Initialized], 0
                Je      @@Error
;
                Mov     di, offset TotalBytesL
                Mov     si, di

                Mov     ax, PNumBytesL
                Stosw
                Mov     ax, PNumBytesH
                Stosw

                Mov     ax, PSourceHandle
                Stosw
                Mov     ax, PSourceOfsL
                Stosw
                Mov     ax, PSourceOfsH
                Stosw

                Xor     ax, ax
                Stosw
                Mov     ax, PDestOfs
                Stosw
                Mov     ax, PDestSeg
                Stosw

                Mov     ax, 0B00h
                Call    [Dispatcher]
                And     ax, ax
                Jz      @@Error
                Xor     ax, ax
;
@@Exit:         Pop     di si es ds bp
                Retf
;
@@Error:        Mov     ax, 1
                Jmp     @@Exit

ENDP            _CopyFromXMS
;
PUBLIC          _XMSFreeAll
;
PROC            _XMSFreeAll

                Push    ds es si di bp

                Push    cs cs
                Pop     ds es

                Mov     si, offset HandleTable
                Mov     di, MAXHANDLES

@@10:           Lodsw
                And     ax, ax
                Jz      @@20

                Push    ax
                Call    FAR _XMSFree
                Pop     ax

@@20:           Dec     di
                Jnz     @@10

                Mov     [Initialized], 0

                Pop     bp di si es ds
                Retf

ENDP            _XMSFreeAll
;
ENDS            XMSCode
;
END
